//main.c

#include <stdio.h>
#include <string.h>
#include "main.h"

char	fnameH[_szname];
char	fnameL[_szname];
char	fname[_szname];

int main(int argc, char *argv[])
{
	int	acnt	= 1;
	int	res;
	if(argc < 2)
	{
		printf("Не укакзаны параметры!\n");
		printf("Примените параметр \"--help\" для подсказки\n");
		return 1;
	}
	while(acnt < argc)
	{
		if(strcmp(argv[acnt], "--help") == 0)
		{
			printf(_help_);
			break;
		}
		else if(strcmp(argv[acnt], "--glueOR") == 0)
		{
			memset(&fnameH[0], 0, _szname);
			memset(&fnameL[0], 0, _szname);
			memset(&fname[0], 0, _szname);
			acnt++;
			if(acnt >= argc)
			{
				printf(_err1_);
				return 3;
			}
			strcpy(&fnameH[0], argv[acnt]);
			acnt++;
			if(acnt >= argc)
			{
				printf(_err1_);
				return 3;
			}
			strcpy(&fnameL[0], argv[acnt]);
			acnt++;
			if(acnt >= argc)
			{
				printf(_err1_);
				return 3;
			}
			strcpy(&fname[0], argv[acnt]);
			res = glue(_OR_);
			if(res < 0)
				return 4;
			break;
		}
		else if(strcmp(argv[acnt], "--glueAND") == 0)
		{
			memset(&fnameH[0], 0, _szname);
			memset(&fnameL[0], 0, _szname);
			memset(&fname[0], 0, _szname);
			acnt++;
			if(acnt >= argc)
			{
				printf(_err1_);
				return 3;
			}
			strcpy(&fnameH[0], argv[acnt]);
			acnt++;
			if(acnt >= argc)
			{
				printf(_err1_);
				return 3;
			}
			strcpy(&fnameL[0], argv[acnt]);
			acnt++;
			if(acnt >= argc)
			{
				printf(_err1_);
				return 3;
			}
			strcpy(&fname[0], argv[acnt]);
			res = glue(_AND_);
			if(res < 0)
				return 4;
			break;
		}
		else
		{
			printf("параметр: %s не понятен\n", argv[acnt]);
			return 2;
		}
		acnt++;
	}
	return 0;
}


int	glue(int XXp)
{
	FILE *f1, *f2, *f3;
	int	d1, d2, out;
	f1 = fopen(&fnameH[0], "rb");
	if(f1 == NULL)
	{
		printf(_ferr1_); printf("%s\n\n", &fnameH[0]);
		return -1;
	}
	f2 = fopen(&fnameL[0], "rb");
	if(f2 == NULL)
	{
		printf(_ferr1_); printf("%s\n\n", &fnameL[0]);
		fclose(f1);
		return -1;
	}
	f3 = fopen(&fname[0], "wb");
	if(f2 == NULL)
	{
		printf(_ferr1_); printf("%s\n\n", &fname[0]);
		fclose(f1);
		fclose(f2);
		return -1;
	}
	while(1)
	{
		d1 = fgetc(f1);
		if(d1 == EOF)
			break;
		d2 = fgetc(f2);
		if(d2 == EOF)
			break;
		if(XXp == _OR_)
		{	out = d1 | d2;
			fputc((char)(out), f3);
		}
		else if(XXp == _AND_)
		{
			out = d1 & d2;
			fputc((char)(out), f3);
		}
	}
	fclose(f1);
	fclose(f2);
	fclose(f3);
	return 0;
}


